package org.isaacparker.javasayshi;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

public class AppFrame {
	
	private String[][][][][] productStr;

	protected Shell shell;
	private Table table;
	private Text txtItemname;
	private Text txtItemprice;
	private Text txtItemtaxrate;
	private Text txtItemnumber;
	private Text txtPricetype;
	private TableItem tableItem;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			AppFrame window = new AppFrame();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell();
		shell.setSize(849, 629);
		shell.setText("SWT Application");

		Label lblTotalmarker = new Label(shell, SWT.NONE);
		lblTotalmarker.setAlignment(SWT.RIGHT);
		lblTotalmarker.setFont(SWTResourceManager.getFont("Lucida Grande", 11, SWT.BOLD));
		lblTotalmarker.setBounds(390, 478, 47, 14);
		lblTotalmarker.setText("Total: $");
		Label lblSubtotal = new Label(shell, SWT.NONE);
		lblSubtotal.setAlignment(SWT.RIGHT);
		lblSubtotal.setBounds(376, 458, 59, 14);
		lblSubtotal.setText("Subtotal: $");

		Label lblTotaLabel = new Label(shell, SWT.NONE);
		lblTotaLabel.setBounds(443, 478, 59, 14);
		Label lblSubtotallabel = new Label(shell, SWT.NONE);
		lblSubtotallabel.setBounds(443, 458, 59, 14);

		Label lblItemName = new Label(shell, SWT.NONE);
		lblItemName.setBounds(10, 10, 125, 14);
		lblItemName.setText("Item Name");
		Label lblItemPrice = new Label(shell, SWT.NONE);
		lblItemPrice.setBounds(141, 10, 64, 14);
		lblItemPrice.setText("Item Price");
		Label lblItemNumber = new Label(shell, SWT.NONE);
		lblItemNumber.setBounds(292, 10, 145, 14);
		lblItemNumber.setText("Item Number");
		Label lblTaxRate = new Label(shell, SWT.NONE);
		lblTaxRate.setBounds(211, 10, 75, 14);
		lblTaxRate.setText("Tax Rate");
		Label lblPriceType = new Label(shell, SWT.NONE);
		lblPriceType.setBounds(443, 10, 59, 14);
		lblPriceType.setText("Price Type");

		txtItemname = new Text(shell, SWT.BORDER);
		txtItemname.setBounds(10, 30, 125, 19);
		txtItemprice = new Text(shell, SWT.BORDER);
		txtItemprice.setBounds(141, 30, 64, 19);
		txtItemtaxrate = new Text(shell, SWT.BORDER);
		txtItemtaxrate.setBounds(211, 30, 75, 19);
		txtItemnumber = new Text(shell, SWT.BORDER);
		txtItemnumber.setBounds(292, 30, 145, 19);
		txtPricetype = new Text(shell, SWT.BORDER);
		txtPricetype.setBounds(443, 30, 64, 19);

		table = new Table(shell, SWT.BORDER | SWT.FULL_SELECTION);
		table.setBounds(10, 61, 497, 391);
		table.setHeaderVisible(true);
		table.setLinesVisible(true);

		TableColumn tblclmnItemName = new TableColumn(table, SWT.NONE);
		tblclmnItemName.setWidth(127);
		tblclmnItemName.setText("Item Name");
		TableColumn tblclmnItemPrice = new TableColumn(table, SWT.NONE);
		tblclmnItemPrice.setWidth(70);
		tblclmnItemPrice.setText("Item Price");
		TableColumn tblclmnTaxRate = new TableColumn(table, SWT.NONE);
		tblclmnTaxRate.setWidth(84);
		tblclmnTaxRate.setText("Tax Rate");
		TableColumn tblclmnItemNumber = new TableColumn(table, SWT.NONE);
		tblclmnItemNumber.setWidth(152);
		tblclmnItemNumber.setText("Item Number");
		TableColumn tblclmnPriceType = new TableColumn(table, SWT.NONE);
		tblclmnPriceType.setWidth(62);
		tblclmnPriceType.setText("Price Type");
		//		TableItem tableItem = new TableItem(table, SWT.NONE);
		//		tableItem.setText("New TableItem");
		Button btnEnter = new Button(shell, SWT.NONE);
		btnEnter.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				//System.out.println(getItemValues());
				tableItem = new TableItem(table, SWT.NONE);
				tableItem.setText(getItemValues());
			}
		});
		btnEnter.setBounds(513, 25, 94, 30);
		btnEnter.setText("Enter");

		Button btnTotal = new Button(shell, SWT.NONE);
		btnTotal.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				updateSubtotal();
			}
		});
		btnTotal.setBounds(513, 422, 94, 30);
		btnTotal.setText("Total");

	}

	private String[] getItemValues() {
		String[] itemValues = {txtItemname.getText(), txtItemprice.getText(), txtItemtaxrate.getText(), txtItemnumber.getText(), txtPricetype.getText()};
		return itemValues;
	}
	private void updateSubtotal() {
		table.selectAll();
		String prices = tableItem.getText();
		System.out.println(prices);
	}
}
