package org.isaacparker.ftpstuffwedo;

import java.awt.MouseInfo;
import java.awt.Point;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public class Canvas {

	protected Shell shell;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
//		while(true) {
//			Point p = MouseInfo.getPointerInfo().getLocation();
//			int px = (int)p.getX();
//			int py = (int)p.getY();
//			System.out.println(px + ":" + py);
//		}
		try {
			Canvas window = new Canvas();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell();
		shell.setSize(1200, 1000);
		shell.setText("SWT Application");
		
		org.eclipse.swt.widgets.Canvas canvas = new org.eclipse.swt.widgets.Canvas(shell, SWT.NONE);
		canvas.addMouseMoveListener(new MouseMoveListener() {
			public void mouseMove(MouseEvent arg0) {
				Point p = MouseInfo.getPointerInfo().getLocation();
				int px = (int)p.getX();
				int py = (int)p.getY();
				System.out.println(px + ":" + py);
			}
		});
		canvas.setBounds(10, 10, 800, 800);
	}

}
